package com.marvinelsen.willow.domain

import com.marvinelsen.willow.domain.entities.DictionaryEntry
import com.marvinelsen.willow.domain.entities.Sentence

interface Dictionary {
    suspend fun search(query: String, searchMode: SearchMode): List<DictionaryEntry>

    suspend fun findWordsBeginningWith(entry: DictionaryEntry): List<DictionaryEntry>
    suspend fun findWordsContaining(entry: DictionaryEntry): List<DictionaryEntry>

    suspend fun findCharactersOf(entry: DictionaryEntry): List<DictionaryEntry>

    suspend fun findExampleSentencesFor(entry: DictionaryEntry): List<Sentence>
}
